/*
    Klat - A LaTeX editor for KDE
    
    Copyright (C) 2002-2004  Jori Liesenborgs (jori@lumumba.luc.ac.be)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef KLATEXECSETTINGSDLGIMPL_H

#define KLATEXECSETTINGSDLGIMPL_H

#include "ui_klatexecsettingsdlg.h"
#include "klatexecconfig.h"

class QListViewItem;

class KlatExecConfigModel : public QAbstractListModel
{
	Q_OBJECT
public:
	KlatExecConfigModel(KlatExecConfig * config, QObject * parent=0);
	~KlatExecConfigModel();
	int rowCount(const QModelIndex &parent = QModelIndex()) const;
	int columnCount(const QModelIndex &parent = QModelIndex()) const;
	QVariant data(const QModelIndex &index, int role) const;
	Qt::ItemFlags flags(const QModelIndex &index) const;
	bool setData(const QModelIndex &index, const QVariant &value,int role = Qt::EditRole);
	QVariant headerData(int section, Qt::Orientation orientation, int role = Qt::DisplayRole) const;

private:
	KlatExecConfig * execConfig;
};

class KlatExecSettingsDlgImpl : public QDialog, private Ui::KlatExecSettingsDlg
{
	Q_OBJECT
public:
	KlatExecSettingsDlgImpl(QWidget* parent = 0, const char* name = 0);
	~KlatExecSettingsDlgImpl();
	
	void setExecConfig(const KlatExecConfig &conf)				{ cfg = conf; }
	KlatExecConfig getNewConfig()						{ return cfg; }

	int exec();
private slots:
	void slotAdd();
	void slotEdit();
	void slotDelete();
	void slotUp();
	void slotDown();
private:
	void buildModels();
	int getSelectedPosition();
	int getItemIndex(QListViewItem *item);
	void addMenuEntry(const QString &menuname,const QString &cmd,const QString &cmdLine,const QString &section,const KShortcut &shortcut);
 	
	KlatExecConfig cfg;
	KlatExecConfigModel * cfgModel;
};

#endif // KLATEXECSETTINGSDLGIMPL_H
