/*
    Klat - A LaTeX editor for KDE
    
    Copyright (C) 2002-2004  Jori Liesenborgs (jori@lumumba.luc.ac.be)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "klatoutputtab.h"
#include "klatoutputtab.moc"
#include <ktextedit.h>
#include <kprocess.h>
#include <stdlib.h>
#include <kmenubar.h>

KlatOutputTab::KlatOutputTab(QWidget *parent) : KTabWidget(parent)
{
	out = new KTextEdit(this);
	err = new KTextEdit(this);
	out->setReadOnly(true);
	err->setReadOnly(true);
	addTab(out,"Stdout");
	addTab(err,"Stderr");
}

KlatOutputTab::~KlatOutputTab()
{
}

void KlatOutputTab::newProcess(const QString &cmd)
{
	out->clear();
	err->clear();

	QString cmdinfo = "Executing the following command line:\n";
	
	cmdinfo += cmd;
	cmdinfo += "\n\n";
	addTextToEditWidget(out,cmdinfo.toLatin1());
	addTextToEditWidget(err,cmdinfo.toLatin1());
}

void KlatOutputTab::slotAddStdout(QString strOut)
{
	addTextToEditWidget(out,strOut.toLatin1());
}

void KlatOutputTab::slotAddStderr(QString strErr)
{
	addTextToEditWidget(err,strErr.toLatin1());
}

void KlatOutputTab::addTextToEditWidget(KTextEdit *w,const QString str)
{
		w->append(str);
//	w->moveCursor(QTextCursor::End);
//	w->moveCursor(QTextCursor::StartOfLine);
}

void KlatOutputTab::finishedProcess()
{
	QString info = "\nProcess finished\n";
	addTextToEditWidget(out,info.toLatin1());
	addTextToEditWidget(err,info.toLatin1());
}
